import { Avatar, Typography, Box, Stack, CardHeader } from '@mui/material'
import { useSelector } from 'react-redux'

import { url } from "../../App"


function AboutMe({ me }) {

    const myPostsCount = useSelector(state => state?.promise?.MyPosts?.payload)

    // урл аватара
    const urlAvatar = url.slice(0, -7) + me?.avatar?.url

    return (
        <Box sx={{
            maxWidth: 400
        }}>
            <CardHeader
                avatar={
                    <Avatar
                        sx={{ width: 50, height: 50 }}
                        alt={me?.login}
                        src={urlAvatar}
                    />
                }

                subheader={
                    <Typography variant='h6'>
                        {me?.login}
                    </Typography>
                }
            />
            <Stack
                direction="row"
                spacing={1}
                padding={2}>
                <Typography>
                    {myPostsCount?.length || '0'} публикаций
                </Typography>
                <Typography>
                    {me?.followers?.length || '0'} подписчиков
                </Typography>
                <Typography>
                    {me?.following?.length || '0'} подписок
                </Typography>
            </Stack>
        </Box>

    )
}

export default AboutMe



